unit FileUtils;

interface

uses
    Windows, SysUtils, WinInet, Forms, ShlObj, ActiveX, Variants;

//-----------------------------------------------------------------------------
//  _FILETIME to TDateTime
function FileTimeToDateTime(const AFileTime: TFileTime): TDateTime;
//-----------------------------------------------------------------------------
//  oCgTCY\
function SizeText(const ByteSize: Integer): string;

//-----------------------------------------------------------------------------
//  IẼC^[lbgLbVt@C񋓂
type TEnumCacheFilesProc = function(const lpCacheEntry: PInternetCacheEntryInfo): Boolean of object;
function EnumInternetCacheFiles(Proc: TEnumCacheFilesProc; var AError: String): Boolean;

//-----------------------------------------------------------------------------
//  tH_I
function SelectDirectoryEx(Owner: TForm; const Caption: String;
                const Root: String; var Directory: String): Boolean;

//-----------------------------------------------------------------------------
//  t@C̐擾
function GetShellToolTips(const ShellObj: OleVariant; const Path: String): String;

implementation

//-----------------------------------------------------------------------------
//  _FILETIME to TDateTime
function FileTimeToDateTime(const AFileTime: TFileTime): TDateTime;
var
    LLocal: TFileTime;
    LSystem: TSystemTime;
begin
    //  [JɕύX
    FileTimeToLocalFileTime(AFileTime, LLocal);
    //  VXeɕύX
    FileTimeToSystemTime(LLocal, LSystem);
    //  DelphiɕύX
    Result := SystemTimeToDateTime(LSystem);
end;

//-----------------------------------------------------------------------------
//  oCgTCY\
function SizeText(const ByteSize: Integer): string;
var
    KiloByte: Double;
    //MegaByte: Double;
begin
    KiloByte := ByteSize / 1024;
    //MegaByte := KiloByte / 1024;
    Result := FormatFloat('#,##0 KB', KiloByte);
    //Result := FormatFloat('#,##0.00	MB', MegaByte);

    //  בւ̂߂ɐ擪ɃXy[X𖄂߂
    Result := StringOfChar(' ', 10 - Length(Result)) + Result;
end;

//-----------------------------------------------------------------------------
//  IẼC^[lbgLbVt@C񋓂
//-----------------------------------------------------------------------------
//  http://forum.nifty.com/fdelphi/samples/01398.html
//  Tv: "IẼLbVt@C"
//  http://www.geocities.jp/wininet_dll_jp/cache1.html
//  FindFirstUrlCacheEntry - WinInet -
//  http://www.runan.net/program/tips/API/wininet_FindFirstUrlCacheEntry.shtml
//  CE.NET 4.2: Wininet LbV̗񋓂ɂ
//  http://support.microsoft.com/default.aspx?scid=kb%3Bja%3B894941
//  http://support.microsoft.com/default.aspx?scid=kb%3Bja%3B189170
//  ݁`pp̎d - lbg[NAC^[lbg
//  http://www.mitene.or.jp/~sugisita/vb6_net.html

//  //-----------------------------------------------------------------------------
//  //  tH[錾
//  type
//    TForm1 = class(TForm)
//      procedure Button1Click(Sender: TObject);
//    private
//      FPrevFile: String;
//      function EnumCacheFile(const lpCacheEntry: PInternetCacheEntryInfo): Boolean;
//    public
//  
//    end;
//  
//  //-----------------------------------------------------------------------------
//  //  LbV񋓗pR[obN֐
//  function TForm1.EnumCacheFile(const lpCacheEntry: PInternetCacheEntryInfo): Boolean;
//  var
//      LPath: String;
//  begin
//      //  񕶎ϐɎ߂ȂƉ?
//      LPath := (lpCacheEntry^.lpszLocalFileName);
//      //  (Ô)݊mF
//      if (FileExists(LPath)) then
//      begin
//          //  Ȃ? t@C2񋓂?
//          if (FPrevFile <> LPath) then
//          begin
//              //  TODO
//          end;
//          FPrevFile := LPath;
//      end;
//      //  񋓑s
//      Result := True;
//  end;
//  //-----------------------------------------------------------------------------
//  //  
//  procedure TForm1.Button1Click(Sender: TObject);
//  begin
//      EnumInternetCacheFiles(EnumCacheFile, LErr);
//  end;

function EnumInternetCacheFiles(Proc: TEnumCacheFilesProc; var AError: String): Boolean;
var
    dwEntrySize: DWORD;
    hCacheDir: THandle;
    lpCacheEntry: PInternetCacheEntryInfo;
    LError: Cardinal;
    LResult: Boolean;
begin
    Result := False;

    //  擾̈̏TCY(ȂȂ[Ȃ)
    dwEntrySize := MAX_CACHE_ENTRY_INFO_SIZE;
    //  擾̈m
    GetMem(lpCacheEntry, dwEntrySize);
    //  LbVnh
    hCacheDir := 0;

    //  邩AvIɎs܂ł蒼
    while (True) do
    begin
        //  \̂ɃTCYݒ
        lpCacheEntry^.dwStructSize := dwEntrySize;
        //  LbVnh擾
        hCacheDir := FindFirstUrlCacheEntryEx(
                nil, 0, NORMAL_CACHE_ENTRY or STICKY_CACHE_ENTRY,
                0, lpCacheEntry, @dwEntrySize, nil, nil, nil);
        //  
        if (hCacheDir <> 0) then
        begin
            Break;
        end
        //  s
        else
        begin
            LError := GetLastError();
            //  LbVȂ
            if (LError = ERROR_NO_MORE_ITEMS) then
            begin
                Result := True;
                //  
                FreeMem(lpCacheEntry);
                //  I
                Exit;
            end
            //  obt@̗eʕs(dwEntrySize ɕKvTCY)
            else if (LError = ERROR_INSUFFICIENT_BUFFER) then
            begin
                //  obt@g
                ReallocMem(lpCacheEntry, dwEntrySize);
            end
            //  ǂ悤Ȃ
            else
            begin
                AError := SysErrorMessage(LError);
                //  
                FreeMem(lpCacheEntry);
                //  I
                Exit;
            end;
        end;
    end;

    //  ۂɃLbV񋓂(łɂЂƂڂ͎擾ς)
    while (True) do
    begin
        //  R[obN
        LResult := Proc(lpCacheEntry);
        //  񋓒fH
        if (not LResult) then
        begin
            Result := True;
            //  [U[ɂLZ
            AError := SysErrorMessage(1223);
            //  I
            Break;
        end;

        //  \̂ɃTCYݒ
        lpCacheEntry^.dwStructSize := dwEntrySize;
        //  ̃t@C
        LResult := FindNextUrlCacheEntryEx(hCacheDir, lpCacheEntry, @dwEntrySize, nil, nil, nil);
        //  s
        if (not LResult) then
        begin
            LError := GetLastError();
            //  LbVȂ
            if (LError = ERROR_NO_MORE_ITEMS) then
            begin
                Result := True;
                AError := SysErrorMessage(LError);
                //  I
                Exit;
            end
            //  obt@̗eʕs(dwEntrySize ɕKvTCY)
            else if (LError = ERROR_INSUFFICIENT_BUFFER) then
            begin
                //  obt@g
                ReallocMem(lpCacheEntry, dwEntrySize);
            end
            //  ǂ悤Ȃ
            else
            begin
                AError := SysErrorMessage(LError);
                //  I
                Break;
            end;
        end;
    end;

    //  
    FindCloseUrlCache(hCacheDir);
    FreeMem(lpCacheEntry);
end;


//-----------------------------------------------------------------------------
//  ǔSelectDirectory@\_E
//  http://forum.nifty.com/fdelphi/samples/01269.html
function BrowseFolderProc(hWindow: HWND; uMsg: UINT; lParam: LPARAM;
                                            lpData: LPARAM): Integer; stdcall;
var
    PathName: array[0..MAX_PATH] of Char;
begin
    case uMsg of
    BFFM_INITIALIZED:
        begin
            SendMessage(hWindow, BFFM_SETSELECTION, WPARAM(True), lpData);
        end;
    BFFM_SELCHANGED:
        begin
            SHGetPathFromIDList(PItemIDList(lParam), @PathName);
            SendMessage(hWindow, BFFM_SETSTATUSTEXT, 0, LongInt(PChar(@PathName)));
        end;
    end;
    Result := 0;
end;
//-----------------------------------------------------------------------------
function SelectDirectoryEx(Owner: TForm; const Caption: String;
                const Root: String; var Directory: String): Boolean;
var
    IDList: PItemIDList;
    BI: TBrowseInfo;
    Malloc:IMalloc;
    WindowList: Pointer;
    Buffer: PChar;
begin
    Result := False;
    Directory := '';
    FillChar(BI, SizeOf(BI), 0);
    if (ShGetMalloc(Malloc) = S_OK) and (Malloc <> nil) then
    begin
        Buffer := Malloc.Alloc(MAX_PATH);
        try
            BI.hwndOwner      := Owner.Handle;
            BI.pidlRoot       := nil;
            BI.pszDisplayName := Buffer;
            BI.lpszTitle      := PChar(Caption);
            BI.ulFlags        := BIF_STATUSTEXT or BIF_RETURNONLYFSDIRS;
            BI.lpfn           := @BrowseFolderProc;
            BI.lParam         := integer(PChar(Root));

            WindowList := DisableTaskWindows(0);
            try
                IDList := ShBrowseForFolder(BI);
            finally
                EnableTaskWindows(WindowList);
            end;

            Result := (IDList <> nil);
            if Result then
            begin
                ShGetPathFromIDList(IDList, Buffer);
                Malloc.Free(IDList);
                Directory := IncludeTrailingPathDelimiter(Buffer);
            end;
        finally
            Malloc.Free(Buffer);
        end;
    end;
end;

//-----------------------------------------------------------------------------
//  t@C̐擾
function GetShellToolTips(const ShellObj: OleVariant; const Path: String): String;
var
    LFolder: OleVariant;
    LFolderItem: OleVariant;
begin
    //  ShellnIuWFNg
    LFolder := ShellObj.NameSpace(OleVariant(ExtractFilePath(Path)));
    LFolderItem := LFolder.ParseName(ExtractFileName(Path));

    //  擾
    Result := LFolder.GetDetailsOf(LFolderItem, -1);

    //  ShellnIuWFNg
    LFolderItem := Unassigned;
    LFolder := Unassigned;
end;

end.
