unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, ComCtrls, StdCtrls, WinInet, Buttons;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    PageControl1: TPageControl;
    TabCacheView: TTabSheet;
    Panel2: TPanel;
    EditInternetCache: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    EditTargtExtension: TEdit;
    Label3: TLabel;
    LviewCashedFile: TListView;
    Panel3: TPanel;
    Label4: TLabel;
    EditEnumCacheError: TEdit;
    BtnVersion: TBitBtn;
    BtnRefresh: TBitBtn;
    BtnCopyTo: TBitBtn;
    TabTagConv: TTabSheet;
    Panel4: TPanel;
    BtnTagConv: TBitBtn;
    Label8: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label9: TLabel;
    MemConvedTag: TMemo;
    ChkBackToClipBoard: TCheckBox;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure LviewCashedFileColumnClick(Sender: TObject;
      Column: TListColumn);
    procedure LviewCashedFileDblClick(Sender: TObject);
    procedure BtnCopyToClick(Sender: TObject);
    procedure BtnVersionClick(Sender: TObject);
    procedure BtnRefreshClick(Sender: TObject);
    procedure BtnTagConvClick(Sender: TObject);
  private
    FPrevFile: String;
    FShell: OleVariant;
    procedure UpdateCacheView();
    function EnumCacheFile(const lpCacheEntry: PInternetCacheEntryInfo): Boolean;
  public

  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

uses
    Info, ShlObj, StrUtils, FileUtils, ComObj, ClipBrd;

//=============================================================================
//  C^[lbgLbV֌W

//-----------------------------------------------------------------------------
//  ʒu
const
    //COL_NAME: Integer = 0;
    COL_EXT : Integer = 0;
    COL_SIZE: Integer = 1;
    COL_DATE: Integer = 2;
    COL_DESC: Integer = 3;
    COL_PATH: Integer = 4;
//-----------------------------------------------------------------------------
//  E~tO
//  Tv: "ListViewڍו\̶Ѹد̿"
//  http://forum.nifty.com/fdelphi/samples/00506.html
var
    FSortFlag: array[0..4] of Integer = (1, 1, 1, 1, 1);
//-----------------------------------------------------------------------------
//  Xgr[\[gp֐
function SortProc(Item1, Item2: TListItem; SortCol: Integer): Integer; stdcall;
var
    LItem1, LItem2: String;
begin
    //  LvVŃ\[g
    if (SortCol = 0) then
    begin
        LItem1 := TListItem(Item1).Caption;
        LItem2 := TListItem(Item2).Caption;
    end
    //  ׍ڂŃ\[g
    else
    begin
        LItem1 := TListItem(Item1).SubItems[SortCol - 1];
        LItem2 := TListItem(Item2).SubItems[SortCol - 1];
    end;

    //  r
    Result := FSortFlag[SortCol] * AnsiCompareText(LItem1, LItem2);
end;

//-----------------------------------------------------------------------------
//  LbV񋓗pR[obN֐
function TForm1.EnumCacheFile(const lpCacheEntry: PInternetCacheEntryInfo): Boolean;
var
    LPath: String;
    LName: String;
    LExts: String;
    LExt: String;
    LItem: TListItem;
    LSize: Cardinal;
    LDate: TDateTime;
    LTitle: String;
begin
    //  i荞ނ߂̊gqQ
    LExts := EditTargtExtension.Text;
    //  񕶎ϐɎ߂ȂƉ?
    LPath := (lpCacheEntry^.lpszLocalFileName);
    //  gqo
    LExt := ExtractFileExt(LPath);
    //  (Ô)݊mFƊgq`FbN
    if (FileExists(LPath) and AnsiContainsText(LExts, LExt)) then
    begin
        //  Ȃ? t@C2񋓂?
        if (FPrevFile <> LPath) then
        begin
            //  t@Ĉ
            LName := ExtractFileName(LPath);
            //  TCY擾(?)
            LSize := (lpCacheEntry^.dwSizeHigh) or (lpCacheEntry^.dwSizeLow);
            //  t擾
            LDate := FileTimeToDateTime(lpCacheEntry^.LastModifiedTime);
            //  擾
            LTitle := GetShellToolTips(FShell, LPath);
            LTitle := StringReplace(LTitle, #10, ' | ', [rfReplaceAll]);

            //  ACeǉ
            LItem := LviewCashedFile.Items.Add();
            //  ̐ݒ
            LItem.Caption := LName;
            //  gq
            LItem.SubItems.Add(LExt);
            //  TCY
            LItem.SubItems.Add(SizeText(LSize));
            //  t
            LItem.SubItems.Add(FormatDateTime('yyyy/mm/dd hh:nn:ss', LDate));
            //  
            LItem.SubItems.Add(LTitle);
            //  tpX
            LItem.SubItems.Add(LPath);
        end;
        FPrevFile := LPath;
    end;
    //  񋓑s
    Result := True;
end;

//-----------------------------------------------------------------------------
//  C^[lbgLbVr[AXV
procedure TForm1.UpdateCacheView();
var
    LPath: String;
    LErr: String;
begin
    //  LbVtH_̃pX擾
    LPath := IncludeTrailingPathDelimiter(GetSpecialFolderPath(CSIDL_INTERNET_CACHE));
    EditInternetCache.Text := LPath;

    //  XgNA
    LviewCashedFile.Clear();
    LviewCashedFile.Items.BeginUpdate();

    //  ShellIuWFNg擾
    FShell := CreateOleObject('Shell.Application');

    //  
    EnumInternetCacheFiles(EnumCacheFile, LErr);
    EditEnumCacheError.Text := LErr;

    //  ShellIuWFNg
    FShell := Unassigned;

    //  gqŃ\[g
    LviewCashedFile.CustomSort(@SortProc, 1);

    LviewCashedFile.Items.EndUpdate();
end;

//-----------------------------------------------------------------------------
//  ^CgNbNŃ\[g
procedure TForm1.LviewCashedFileColumnClick(Sender: TObject;
  Column: TListColumn);
begin
    //  \[g
    LviewCashedFile.CustomSort(@SortProc, Column.Index);
    //  E~؂ւ
    FSortFlag[Column.Index] := - FSortFlag[Column.Index];
end;

//-----------------------------------------------------------------------------
//  LbVt@CɃANZX
procedure TForm1.LviewCashedFileDblClick(Sender: TObject);
var
    LItem: TListItem;
    LPath: String;
begin
    LItem := LviewCashedFile.Selected;
    if (LItem <> nil) then
    begin
        //  tpX
        LPath := LItem.SubItems.Strings[COL_PATH];
        if (FileExists(LPath)) then
        begin
            OpenFilePropertyDialog(LPath);
        end;
    end;    
end;

//-----------------------------------------------------------------------------
//  Rs[
procedure TForm1.BtnCopyToClick(Sender: TObject);
var
    LDir: String;
    i: Integer;
    LItem: TListItem;
    LSrc, LDst: String;
    LExactName: String;
    LExt: String;
    LSerif: Integer;
begin
    //  tH_I
    if (SelectDirectoryEx(Self, 'Rs[̃tH_I', 'Desktop', LDir)) then
    begin
        for i := 0 to LviewCashedFile.Items.Count - 1 do
        begin
            LItem := LviewCashedFile.Items.Item[i];
            if (LItem.Checked) then
            begin
                LSrc := LItem.SubItems.Strings[COL_PATH];
                LExactName := ChangeFileExt(ExtractFileName(LSrc), '');
                LExt := ExtractFileExt(LSrc);

                //  t@CdȂw
                LSerif := 0;
                while (True) do
                begin
                    LDst := LDir + LExactName + LExt;
                    if (not FileExists(LDst)) then Break;
                    LExactName := LExactName + '_' + IntToHex(LSerif, 4);
                end;

                //  Rs[
                if (not CopyFile(PChar(LSrc), PChar(LDst), True)) then
                begin
                    EditEnumCacheError.Text := SysErrorMessage(GetLastError());
                    Break;
                end;
            end;
        end;
    end;
end;

//-----------------------------------------------------------------------------
//  \XV
procedure TForm1.BtnRefreshClick(Sender: TObject);
begin
    //  LbVr[AXV
    Screen.Cursor := crHourGlass;
    UpdateCacheView();
    Screen.Cursor := crDefault;
end;

//=============================================================================
//  TagConv

//-----------------------------------------------------------------------------
//  "<"">""&"AHTMLŐ\邽߂̕ϊ
function ChangeHTMLSpecialChar(Text: String): String;
const
    SRC_TAG: array[0..2] of String = ('&', '<', '>');
    DST_TAG: array[0..2] of String = ('&amp;', '&lt;', '&gt;');
var
    i: Integer;
begin
    //ϊRs[
    Result := Text;

    //bAfor i := 0 to 2 do
    for i := Low(SRC_TAG) to High(SRC_TAG) do
    begin
        //u
        Result := StringReplace(Result, SRC_TAG[i], DST_TAG[i], [rfReplaceAll]);
    end;
end;

//-----------------------------------------------------------------------------
//  ^O^Oɕϊ
procedure TForm1.BtnTagConvClick(Sender: TObject);
begin
    if (Clipboard.HasFormat(CF_TEXT)) then
    begin
        MemConvedTag.Text := ChangeHTMLSpecialChar(Clipboard.AsText);
        MemConvedTag.SelectAll();
        MemConvedTag.SetFocus();
        if (ChkBackToClipBoard.Checked) then
        begin
            Clipboard.AsText := MemConvedTag.Text;
        end;
    end;
end;

//=============================================================================
//  Form

//-----------------------------------------------------------------------------
//  N
procedure TForm1.FormCreate(Sender: TObject);
begin
    //  󋵕
    LoadPropertyFromFile(ChangeFileExt(ParamStr(0), '.ini'), Self);
end;

//-----------------------------------------------------------------------------
//  I
procedure TForm1.FormDestroy(Sender: TObject);
begin
    //  󋵕ۑ
    SavePropertyToFile(ChangeFileExt(ParamStr(0), '.ini'), Self);
end;

//-----------------------------------------------------------------------------
//  o[W
procedure TForm1.BtnVersionClick(Sender: TObject);
begin
    OpenInfoForm();
end;

end.
